/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TK_IDENT = 258,
     TK_CONST = 259,
     TK_DOTDOTDOT = 260,
     TK_UMINUS = 261,
     TK_UPLUS = 262,
     TK_POW = 263,
     TK_LESS = 264,
     TK_LESSEQ = 265,
     TK_MORE = 266,
     TK_MOREEQ = 267,
     TK_NOTEQ = 268,
     TK_LAND = 269,
     TK_LOR = 270,
     TK_BAND = 271,
     TK_BOR = 272,
     TK_JOIN = 273,
     TK_IF = 274,
     TK_THEN = 275,
     TK_ELSE = 276,
     TK_CHAR = 277,
     TK_SHORT = 278,
     TK_CLASS = 279,
     TK_SCOPE = 280,
     TK_INT = 281,
     TK_FLOAT = 282,
     TK_DOUBLE = 283,
     TK_SIGNED = 284,
     TK_UNSIGNED = 285,
     TK_COMPLEX = 286,
     TK_SEPARATOR = 287,
     TK_DIALOG = 288,
     TK_LSHIFT = 289,
     TK_RSHIFT = 290,
     TK_PNOTEQ = 291,
     TK_PEQ = 292,
     TK_EQ = 293,
     TK_APPLICATION = 294
   };
#endif
/* Tokens.  */
#define TK_IDENT 258
#define TK_CONST 259
#define TK_DOTDOTDOT 260
#define TK_UMINUS 261
#define TK_UPLUS 262
#define TK_POW 263
#define TK_LESS 264
#define TK_LESSEQ 265
#define TK_MORE 266
#define TK_MOREEQ 267
#define TK_NOTEQ 268
#define TK_LAND 269
#define TK_LOR 270
#define TK_BAND 271
#define TK_BOR 272
#define TK_JOIN 273
#define TK_IF 274
#define TK_THEN 275
#define TK_ELSE 276
#define TK_CHAR 277
#define TK_SHORT 278
#define TK_CLASS 279
#define TK_SCOPE 280
#define TK_INT 281
#define TK_FLOAT 282
#define TK_DOUBLE 283
#define TK_SIGNED 284
#define TK_UNSIGNED 285
#define TK_COMPLEX 286
#define TK_SEPARATOR 287
#define TK_DIALOG 288
#define TK_LSHIFT 289
#define TK_RSHIFT 290
#define TK_PNOTEQ 291
#define TK_PEQ 292
#define TK_EQ 293
#define TK_APPLICATION 294




/* Copy the first part of user declarations.  */
#line 1 "parse.y"


/* Parse ip's macro language.
 */

/*

    Copyright (C) 1991-2003 The National Gallery

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

/*

    These files are distributed with VIPS - http://www.vips.ecs.soton.ac.uk

 */

#include "ip.h"

/*
#define DEBUG
 */

/* trace text read system
#define DEBUG_CHARACTER
 */

#define YYERROR_VERBOSE

/* Last top-level symbol we made.
 */
Symbol *last_top_sym;

/* Global .. the symbol whose definition we are currently parsing, the symbol
 * which all top defs in this parse action should be made local to,
 * and the return point if we find a syntax error.
 */
static Symbol *current_symbol;
static Symbol *root_symbol;
jmp_buf parse_error_point;

/* The current parse context.
 */
static Compile *current_compile = NULL;
static ParseNode *current_parsenode = NULL;

/* A list of the top-level symbols we've defined so far in this parse action. 
 * We don't allow a single parse action to define a symbol more than once.
 */
static GSList *parse_sofar = NULL;

/* The kit we are adding new symbols to.
 */
static Toolkit *current_kit;

/* Where it should go in the kit.
 */
static int tool_position;

/* Lineno of start of last top-level def.
 */
static int last_top_lineno;

/* Text we've gathered in this lex.
 */
BufInfo lex_text;
static char lex_text_buffer[MAX_STRSIZE];

/* Stack of symbols for parser - each represents a new scope level.
 */
static Symbol *scope_stack_symbol[MAX_SSTACK];
static Compile *scope_stack_compile[MAX_SSTACK];
static int scope_sp = 0;

/* Here for errors in parse. Can be called by some of the tree builders.
 */
/*VARARGS1*/
void
yyerror( const char *sub, ... )
{
	va_list ap;
 	char buf[4096];

        va_start( ap, sub );
        (void) im_vsnprintf( buf, 4096, sub, ap );
        va_end( ap );

	error_top( _( "Parse error." ) );

	if( last_top_sym ) 
		error_sub( _( "Error in %s: %s" ), 
			IOBJECT( last_top_sym )->name, buf );
	else
		error_sub( _( "Error: %s" ), buf );

	longjmp( parse_error_point, -1 );
}

InputState input_state;

/* Attach yyinput to a file.
 */
void
attach_input_file( iOpenFile *of )
{
	InputState *is = &input_state;

#ifdef DEBUG
	printf( "attach_input_file: \"%s\"\n", of->fname );
#endif /*DEBUG*/

	/* Need to clear flex/bison's buffers in case we abandoned the
	 * previous parse. 
	 */
	yyrestart( NULL );

	is->of = of;
	is->str = NULL;
	is->strpos = NULL;
	is->bwp = 0;
	is->bspsp = 0;
	is->bsp[is->bspsp] = 0;
	is->lineno = 1;
	is->charno = 0;
	is->pcharno = 0;
	is->charpos = 0;
	is->oldchar = -1;

	/* Init text gatherer.
	 */
	buf_init_static( &lex_text, lex_text_buffer, MAX_STRSIZE );
}

/* Attach yyinput to a string.
 */
void
attach_input_string( const char *str )
{
	InputState *is = &input_state;

#ifdef DEBUG
	printf( "attach_input_string: \"%s\"\n", str );
#endif /*DEBUG*/

	yyrestart( NULL );

	is->of = NULL;
	is->str = (char *) str;
	is->strpos = (char *) str;
	is->bwp = 0;
	is->bspsp = 0;
	is->bsp[is->bspsp] = 0;
	is->lineno = 1;
	is->charno = 0;
	is->pcharno = 0;
	is->charpos = 0;
	is->oldchar = -1;

	/* Init text gatherer.
	 */
	buf_init_static( &lex_text, lex_text_buffer, MAX_STRSIZE );
}

/* Read a character from the input.
 */
int
ip_input( void ) 
{
	InputState *is = &input_state;
	int ch;

#ifdef DEBUG_CHARACTER
	printf( "ip_input: starting ...\n" ); 
#endif /*DEBUG_CHARACTER*/

	if( is->oldchar >= 0 ) {
		/* From unget buffer.
		 */
		ch = is->oldchar;
		is->oldchar = -1;
	}
	else if( is->of ) {
		/* Input from file. 
		 */
		if( (ch = getc( is->of->fp )) == EOF )
			return( 0 );
	}
	else {
		/* Input from string. Make sure we do not read past the end of
		 * the string.
		 */
		if( (ch = *is->strpos) )
			is->strpos++;
		else
			/* No counts to update!
			 */
			return( 0 );
	}

	/* Update counts.
	 */
	if( ch == '\n' ) {
		is->lineno++;
		is->pcharno = is->charno + 1;
		is->charno = 0;
	}
	is->charno++;
	is->charpos++;

	/* Add this character to the characters we have accumulated for this
	 * definition.
	 */
	if( is->bwp >= MAX_STRSIZE )
		yyerror( _( "definition is too long!" ) );
	if( is->bwp >= 0 )
		is->buf[is->bwp] = ch;
	is->bwp++;

	/* Add to lex text buffer.
	 */
	if( is->charno > 0 )
		buf_appendc( &lex_text, ch );

#ifdef DEBUG_CHARACTER
	printf( "ip_input: returning '%c'\n", ch ); 
#endif /*DEBUG_CHARACTER*/

	return( ch );
}

/* Unget an input character.
 */
void
ip_unput( int ch )
{
	InputState *is = &input_state;

	/* Is lex trying to unget the end-of-file marker? Do nothing if it is.
	 */
	if( !ch )
		return;

	if( is->of ) {
		if( ungetc( ch, is->of->fp ) == EOF )
			error( "unget buffer overflow" );
	}
	else {
		if( is->strpos > is->str )
			is->strpos--;	
		else
			/* Save extra char here.
			 */
			is->oldchar = ch;
	}
	
	/* Redo counts.
	 */
	if( ch == '\n' ) {
		is->lineno--;

		/* Restore previous charno.
		 */
		is->charno = is->pcharno;
		is->pcharno = 0;
	}
	is->charno--;
	is->charpos--;
	is->bwp--;

	/* Unget from lex text buffer.
	 */
	if( is->charno > 0 )
		buf_removec( &lex_text, ch );
}

/* Test for end-of-input.
 */
gboolean
is_EOF( void )
{
	InputState *is = &input_state;

	if( is->of )
		return( feof( is->of->fp ) );
	else
		return( *is->str == '\0' );
}

/* Reset/push/pop parser stacks.
 */
static void
scope_reset( void )
{
	scope_sp = 0;
}

static void
scope_push( void )
{
	if( scope_sp == MAX_SSTACK )
		error( "sstack overflow" );
	assert( current_symbol );

	scope_stack_symbol[scope_sp] = current_symbol;
	scope_stack_compile[scope_sp] = current_compile;
	scope_sp += 1;
}

static void
scope_pop( void )
{
	if( scope_sp <= 0 )
		error( "sstack underflow" );

	scope_sp -= 1;
	current_symbol = scope_stack_symbol[scope_sp];
	current_compile = scope_stack_compile[scope_sp];
}

/* Return the text we have accumulated for the current definition. Remove
 * leading and trailing whitespace and spare semicolons. out needs to be
 * MAX_STRSIZE.
 */
static char *
input_text( char *out )
{
	InputState *is = &input_state;
	const char *buf = is->buf;

	int start = is->bsp[is->bspsp];
	int end = is->bwp;
	int len;
	int i;

	for( i = start; i < end && 
		(isspace( buf[i] ) || buf[i] == ';'); i++ )
		;
	start = i;
	for( i = end - 1; i > start && 
		(isspace( buf[i] ) || buf[i] == ';'); i-- )
		;
	end = i + 1;

	len = end - start;

	assert( len < MAX_STRSIZE - 1 );
	im_strncpy( out, buf + start, len + 1 );
	out[len] = '\0';

#ifdef DEBUG_CHARACTER
	printf( "input_text: level %d, returning \"%s\"\n", 
		is->bspsp, out );
#endif /*DEBUG_CHARACTER*/

	return( out );
}

/* Reset/push/pop input stacks.
 */
static void
input_reset( void )
{
	InputState *is = &input_state;

#ifdef DEBUG_CHARACTER
	printf( "input_reset:\n" );
#endif /*DEBUG_CHARACTER*/

	is->bwp = 0;
	is->bspsp = 0;
	is->bsp[0] = 0;
	buf_init_static( &lex_text, lex_text_buffer, MAX_STRSIZE );
}

static void
input_push( int n )
{
	InputState *is = &input_state;

#ifdef DEBUG_CHARACTER
	printf( "input_push(%d): going to level %d, %d bytes into buffer\n", 
		n, is->bspsp + 1, is->bwp );

	{
		const int len = IM_MIN( is->bwp, 20 );
		int i;

		for( i = is->bwp - len; i < is->bwp; i++ )
			if( is->buf[i] == '\n' )
				printf( "@" );
			else if( is->buf[i] == ' ' || is->buf[i] == '\t' )
				printf( "_" );
			else
				printf( "%c", is->buf[i] );
		printf( "\n" );
		for( i = 0; i < len; i++ )
			printf( "-" );
		printf( "^\n" );
	}
#endif /*DEBUG_CHARACTER*/

	is->bspsp += 1;
	if( is->bspsp >= MAX_SSTACK )
		error( "bstack overflow" );

	is->bsp[is->bspsp] = is->bwp;
}

/* Yuk! We've just done an input_push() to try to grab the RHS of a 
 * definition ... unfortunately, due to token readahead, we've probably 
 * already read the start of the RHS.
 *
 * Back up the start point to just after the last ch character.
 */
static void
input_backtoch( char ch )
{
	InputState *is = &input_state;
	int i;

	for( i = is->bsp[is->bspsp] - 1; i > 0 && is->buf[i] != ch; i-- )
		;

	if( is->buf[i] == ch )
		is->bsp[is->bspsp] = i + 1;
}

/* Move the last input_push() point back 1 character.
 */
static void
input_back1( void )
{
	InputState *is = &input_state;

	if( is->bsp[is->bspsp] > 0 )
		is->bsp[is->bspsp] -= 1;
}

static void
input_pop( void )
{
	InputState *is = &input_state;

#ifdef DEBUG_CHARACTER
	printf( "input_pop: %d bytes into buffer\n", input_state.bwp );
#endif /*DEBUG_CHARACTER*/

	if( is->bspsp <= 0 )
		error( "bstack underflow" );

	is->bspsp--;
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 470 "parse.y"
{
	struct sym_table *yy_symtab;
	ParseNode *yy_node;
	Symbol *yy_sym;
	char *yy_name;
	ParseConst yy_const;
	UnOp yy_uop;
	BinOp yy_binop;
}
/* Line 187 of yacc.c.  */
#line 653 "parse.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 666 "parse.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  31
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1244

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  61
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  32
/* YYNRULES -- Number of rules.  */
#define YYNRULES  102
/* YYNRULES -- Number of states.  */
#define YYNSTATES  187

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   294

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    47,     2,     2,     2,    46,     2,     2,
      50,    59,    44,    42,    36,    43,    54,    45,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    49,    56,
       2,    55,     2,    53,    37,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    51,     2,    60,    38,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    57,     2,    58,    48,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    39,    40,    41,    52
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    13,    15,    18,    21,    22,
      25,    27,    30,    32,    36,    37,    40,    41,    45,    46,
      47,    48,    55,    56,    59,    63,    65,    66,    69,    72,
      79,    81,    85,    88,    89,    92,    93,    97,    98,   103,
     104,   107,   111,   113,   115,   117,   124,   127,   131,   133,
     135,   138,   142,   147,   153,   155,   156,   160,   162,   166,
     170,   174,   178,   182,   186,   190,   194,   198,   202,   206,
     210,   214,   218,   222,   226,   230,   234,   238,   242,   246,
     250,   254,   258,   262,   266,   272,   273,   275,   276,   278,
     284,   290,   296,   302,   308,   314,   319,   324,   329,   335,
     338,   341,   344
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      62,     0,    -1,    54,    64,    -1,    38,    65,    -1,    44,
      71,    81,    -1,    63,    -1,    16,    86,    -1,    37,    85,
      -1,    -1,    64,    65,    -1,    66,    -1,    67,    81,    -1,
      32,    -1,    33,     4,     4,    -1,    -1,    68,    69,    -1,
      -1,     3,    70,    71,    -1,    -1,    -1,    -1,    72,    75,
      73,    76,    74,    80,    -1,    -1,    75,     3,    -1,    55,
      24,    77,    -1,    79,    -1,    -1,    78,    85,    -1,    55,
      86,    -1,    55,    86,    36,    86,    81,    79,    -1,    56,
      -1,    57,    82,    58,    -1,    57,    58,    -1,    -1,    56,
      81,    -1,    -1,    69,    83,    81,    -1,    -1,    82,    69,
      84,    81,    -1,    -1,    85,    86,    -1,    50,    86,    59,
      -1,     4,    -1,     3,    -1,    25,    -1,    19,    86,    20,
      86,    21,    86,    -1,    86,    86,    -1,    51,    87,    60,
      -1,    89,    -1,    92,    -1,    86,     5,    -1,    86,     5,
      86,    -1,    86,    36,    86,     5,    -1,    86,    36,    86,
       5,    86,    -1,    88,    -1,    -1,    86,    36,    88,    -1,
      86,    -1,    86,    42,    86,    -1,    86,    49,    86,    -1,
      86,    43,    86,    -1,    86,    53,    86,    -1,    86,    45,
      86,    -1,    86,    44,    86,    -1,    86,    46,    86,    -1,
      86,    18,    86,    -1,    86,     8,    86,    -1,    86,    34,
      86,    -1,    86,    35,    86,    -1,    86,    38,    86,    -1,
      86,    14,    86,    -1,    86,    16,    86,    -1,    86,    37,
      86,    -1,    86,    15,    86,    -1,    86,    17,    86,    -1,
      86,     9,    86,    -1,    86,    10,    86,    -1,    86,    11,
      86,    -1,    86,    12,    86,    -1,    86,    41,    86,    -1,
      86,    13,    86,    -1,    86,    40,    86,    -1,    86,    39,
      86,    -1,    86,    54,     3,    -1,    50,    86,    36,    86,
      59,    -1,    -1,    29,    -1,    -1,    30,    -1,    50,    91,
      22,    59,    86,    -1,    50,    29,    22,    59,    86,    -1,
      50,    90,    23,    59,    86,    -1,    50,    30,    23,    59,
      86,    -1,    50,    90,    26,    59,    86,    -1,    50,    30,
      26,    59,    86,    -1,    50,    27,    59,    86,    -1,    50,
      28,    59,    86,    -1,    50,    31,    59,    86,    -1,    50,
      28,    31,    59,    86,    -1,     6,    86,    -1,    47,    86,
      -1,    48,    86,    -1,     7,    86,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   517,   517,   519,   521,   526,   548,   553,   559,   562,
     566,   571,   578,   592,   622,   622,   666,   665,   737,   747,
     752,   737,   794,   797,   809,   814,   821,   821,   871,   876,
     884,   886,   888,   891,   894,   899,   898,   907,   905,   916,
     920,   930,   935,   940,   946,   953,   960,   967,   976,   978,
     982,   988,   994,  1000,  1006,  1009,  1018,  1024,  1030,  1035,
    1040,  1045,  1050,  1055,  1060,  1065,  1070,  1075,  1080,  1085,
    1090,  1095,  1100,  1105,  1110,  1115,  1120,  1125,  1130,  1135,
    1140,  1145,  1150,  1155,  1164,  1171,  1172,  1175,  1176,  1179,
    1185,  1192,  1198,  1204,  1210,  1216,  1222,  1228,  1234,  1240,
    1245,  1250,  1255
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TK_IDENT", "TK_CONST", "TK_DOTDOTDOT",
  "TK_UMINUS", "TK_UPLUS", "TK_POW", "TK_LESS", "TK_LESSEQ", "TK_MORE",
  "TK_MOREEQ", "TK_NOTEQ", "TK_LAND", "TK_LOR", "TK_BAND", "TK_BOR",
  "TK_JOIN", "TK_IF", "TK_THEN", "TK_ELSE", "TK_CHAR", "TK_SHORT",
  "TK_CLASS", "TK_SCOPE", "TK_INT", "TK_FLOAT", "TK_DOUBLE", "TK_SIGNED",
  "TK_UNSIGNED", "TK_COMPLEX", "TK_SEPARATOR", "TK_DIALOG", "TK_LSHIFT",
  "TK_RSHIFT", "','", "'@'", "'^'", "TK_PNOTEQ", "TK_PEQ", "TK_EQ", "'+'",
  "'-'", "'*'", "'/'", "'%'", "'!'", "'~'", "':'", "'('", "'['",
  "TK_APPLICATION", "'?'", "'.'", "'='", "';'", "'{'", "'}'", "')'", "']'",
  "$accept", "select", "prhs", "main", "onedef", "directive", "topdef",
  "@1", "def", "@2", "sdef", "@3", "@4", "@5", "params", "body", "crhs",
  "@6", "rhs", "locals", "optsemi", "deflist", "@7", "@8", "cexprlist",
  "expr", "listex", "clist", "binop", "signed", "unsigned", "uop", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,    44,    64,    94,   291,
     292,   293,    43,    45,    42,    47,    37,    33,   126,    58,
      40,    91,   294,    63,    46,    61,    59,   123,   125,    41,
      93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    61,    62,    62,    62,    62,    63,    63,    64,    64,
      65,    65,    66,    66,    68,    67,    70,    69,    72,    73,
      74,    71,    75,    75,    76,    76,    78,    77,    79,    79,
      80,    80,    80,    81,    81,    83,    82,    84,    82,    85,
      85,    86,    86,    86,    86,    86,    86,    86,    86,    86,
      87,    87,    87,    87,    87,    87,    88,    88,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    90,    90,    91,    91,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     3,     1,     2,     2,     0,     2,
       1,     2,     1,     3,     0,     2,     0,     3,     0,     0,
       0,     6,     0,     2,     3,     1,     0,     2,     2,     6,
       1,     3,     2,     0,     2,     0,     3,     0,     4,     0,
       2,     3,     1,     1,     1,     6,     2,     3,     1,     1,
       2,     3,     4,     5,     1,     0,     3,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     0,     1,     0,     1,     5,
       5,     5,     5,     5,     5,     4,     4,     4,     5,     2,
       2,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,    39,    14,    18,     8,     0,     5,    43,    42,
       0,     0,     0,    44,     0,     0,    85,    55,     6,    48,
      49,     7,    12,     0,     3,    10,    33,     0,    33,    22,
       2,     1,    99,   102,     0,   100,   101,     0,     0,    86,
      88,     0,     0,     0,     0,    57,     0,    54,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,    40,     0,    33,    11,    16,
      15,     4,    19,     9,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    50,     0,    47,
      66,    75,    76,    77,    78,    80,    70,    73,    71,    74,
      65,    67,    68,    72,    69,    82,    81,    79,    58,    60,
      63,    62,    64,    59,    61,    83,    13,    34,    18,    23,
       0,     0,    95,     0,    96,     0,     0,     0,    97,     0,
       0,     0,     0,    51,    57,    56,    17,     0,    20,    25,
       0,    98,    90,    92,    94,    84,    91,    93,    89,    52,
       0,    26,    28,     0,    45,    53,    57,    24,    39,     0,
      30,     0,    21,    27,    33,    32,    35,     0,     0,    33,
      31,    37,     0,    29,    36,    33,    38
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,    30,    24,    25,    26,    27,    80,   128,
      28,    29,   130,   163,    82,   148,   167,   168,   149,   172,
      78,   177,   179,   185,    21,    74,    46,   145,    19,    43,
      44,    20
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -170
static const yytype_int16 yypact[] =
{
     -13,   159,  -170,   -27,  -170,  -170,     7,  -170,  -170,  -170,
     159,   159,   159,  -170,   159,   159,  1142,   159,   653,  -170,
    -170,   159,  -170,     8,  -170,  -170,   -39,    23,   -39,  -170,
       1,  -170,   101,   101,   445,   101,   101,   -31,   -30,    17,
       4,   -21,   179,     9,    18,   341,   -18,  -170,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,    40,   -32,  1190,    41,   -39,  -170,  -170,
    -170,  -170,    43,  -170,   159,   159,   -15,   159,    20,    26,
      28,   159,   159,  -170,    29,    30,    34,   159,   159,  -170,
     101,  1069,  1069,  1069,  1069,   965,   809,   757,  1017,   861,
     101,    74,    74,   809,   913,   965,   965,   965,  1082,  1082,
    1134,  1134,  1134,   101,  -170,  -170,  -170,  -170,  -170,  -170,
      21,   497,   101,   159,   101,   159,   159,   159,   101,   233,
     159,   159,   159,   653,   393,  -170,  -170,  1172,  -170,  -170,
     159,   101,   101,   101,   101,  -170,   101,   101,   101,   159,
     159,  -170,   549,   -20,   705,   653,   601,  -170,  -170,   159,
    -170,    15,  -170,   159,   287,  -170,  -170,    16,    39,   -39,
    -170,  -170,   159,  -170,  -170,   -39,  -170
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -170,  -170,  -170,  -170,    45,  -170,  -170,  -170,  -169,  -170,
     -33,  -170,  -170,  -170,  -170,  -170,  -170,  -170,   -80,  -170,
      -5,  -170,  -170,  -170,   -68,    -1,  -170,    84,  -170,  -170,
    -170,  -170
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -88
static const yytype_int16 yytable[] =
{
      18,    86,   176,     1,   -14,    22,    23,    31,   181,    32,
      33,    34,    76,    35,    36,    42,    45,    77,    79,    79,
      75,    72,    73,    81,     2,     3,    79,    89,    85,    87,
      90,     4,    94,    22,    23,    95,   170,   171,    91,    88,
      96,     5,    99,   125,   133,   126,   129,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   127,   175,   180,    83,   147,     8,     9,   135,
      10,    11,    48,   131,   132,   136,   134,   137,   140,   141,
     138,   139,    58,   142,   182,   146,   143,   144,   183,    13,
     173,    47,     0,     0,     8,     9,     0,     0,     0,    48,
       0,     0,     0,     0,     0,     0,    66,    67,    68,    69,
      70,    14,    15,    71,    16,    17,    13,    72,    73,     0,
       0,     0,   151,     0,   152,   153,   154,     0,     0,   156,
     157,   158,     0,     0,     0,     0,   162,     0,     0,   164,
      71,    16,    17,     0,    72,    73,     0,     0,   165,   166,
       0,     0,     8,     9,     0,    10,    11,     0,   174,   178,
       0,     0,    75,     0,   184,     0,     0,     0,    12,     0,
     186,   162,     8,     9,    13,    10,    11,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    12,     0,
       0,     0,     0,     0,    13,     0,    14,    15,     0,    16,
      17,     0,     0,    59,    60,    92,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    14,    15,    71,    16,
      17,     0,    72,    73,     0,     0,     8,     9,    93,    10,
      11,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    12,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,    59,    60,     0,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      14,    15,    71,    16,    17,     0,    72,    73,     0,     0,
       8,     9,   155,    10,    11,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    12,     0,     0,     0,
       0,     0,    13,     0,     0,     0,     0,     0,     0,     0,
       0,    59,    60,     0,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    14,    15,    71,    16,    17,     0,
      72,    73,     0,    77,     8,     9,    97,    10,    11,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      12,     0,     0,     0,     0,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,    59,    60,    98,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    14,    15,
      71,    16,    17,     0,    72,    73,     8,     9,   159,    10,
      11,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    12,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,    59,    60,   160,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      14,    15,    71,    16,    17,     0,    72,    73,     8,     9,
       0,    10,    11,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    12,    84,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,     0,     0,    59,
      60,     0,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    14,    15,    71,    16,    17,     0,    72,    73,
       8,     9,     0,    10,    11,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    12,     0,   150,     0,
       0,     0,    13,     0,     0,     0,     0,     0,     0,     0,
       0,    59,    60,     0,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    14,    15,    71,    16,    17,     0,
      72,    73,     8,     9,     0,    10,    11,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    12,     0,
       0,     0,     0,     0,    13,     0,     0,     0,     0,     0,
       0,     0,     0,    59,    60,   169,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    14,    15,    71,    16,
      17,     0,    72,    73,     8,     9,     0,    10,    11,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      12,     0,     0,     0,     0,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,    59,    60,   160,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    14,    15,
      71,    16,    17,     0,    72,    73,     8,     9,     0,    10,
      11,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    12,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,    59,    60,     0,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      14,    15,    71,    16,    17,     0,    72,    73,     8,     9,
       0,    10,    11,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,   -88,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,     0,     0,    59,
      60,     0,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    14,    15,    71,    16,    17,     0,    72,    73,
       8,     9,     0,    10,    11,    48,    49,    50,    51,    52,
      53,    54,     0,    56,    57,    58,     0,     0,     0,     0,
       0,     0,    13,     0,     0,     0,     0,     0,     0,     0,
       0,    59,    60,     0,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    14,    15,    71,    16,    17,     0,
      72,    73,     8,     9,     0,    10,    11,    48,    49,    50,
      51,    52,    53,     0,     0,    56,    57,    58,     0,     0,
       0,     0,     0,     0,    13,     0,     0,     0,     0,     0,
       0,     0,     0,    59,    60,     0,     0,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    14,    15,    71,    16,
      17,     0,    72,    73,     8,     9,     0,    10,    11,    48,
      49,    50,    51,    52,    53,     0,     0,    56,     0,    58,
       0,     0,     0,     0,     0,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,    59,    60,     0,     0,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    14,    15,
      71,    16,    17,     0,    72,    73,     8,     9,     0,    10,
      11,    48,    49,    50,    51,    52,    53,     0,     0,    56,
       0,    58,     0,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,    59,    60,     0,
       0,     0,    63,    64,    65,    66,    67,    68,    69,    70,
      14,    15,    71,    16,    17,     0,    72,    73,     8,     9,
       0,    10,    11,    48,    49,    50,    51,    52,   -88,     0,
       0,     0,     0,    58,     0,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,     0,     0,    59,
      60,     0,     0,     0,   -88,   -88,   -88,    66,    67,    68,
      69,    70,    14,    15,    71,    16,    17,     0,    72,    73,
       8,     9,     0,    10,    11,    48,    49,    50,    51,    52,
      53,     0,     0,     0,     0,    58,     0,     0,     0,     0,
       0,     0,    13,     0,     0,     0,     0,     0,     0,     0,
       0,    59,    60,     0,     0,     0,    63,    64,    65,    66,
      67,    68,    69,    70,    14,    15,    71,    16,    17,     0,
      72,    73,     8,     9,     0,    10,    11,    48,   -88,   -88,
     -88,   -88,     0,     0,     0,     8,     9,    58,    10,    11,
      48,     0,     0,     0,    13,     0,     0,     0,     0,     0,
      58,     0,     0,    59,    60,     0,     0,    13,     0,     0,
       0,    66,    67,    68,    69,    70,    14,    15,    71,    16,
      17,     0,    72,    73,     0,     0,    68,    69,    70,    14,
      15,    71,    16,    17,     0,    72,    73,     8,     9,     0,
      10,    11,    48,     0,     0,     8,     9,     0,    10,    11,
       0,     0,    58,     0,     0,     0,     0,     0,     0,    13,
       0,    12,     0,     0,   -87,     0,     0,    13,     0,    37,
      38,    39,    40,    41,     0,     8,     9,     0,    10,    11,
       0,    14,    15,    71,    16,    17,     0,    72,    73,    14,
      15,    12,    16,    17,     0,     0,   161,    13,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    14,
      15,     0,    16,    17,    59,    60,     0,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,     0,     0,    71,
       0,     0,     0,    72,    73
};

static const yytype_int16 yycheck[] =
{
       1,    31,   171,    16,     3,    32,    33,     0,   177,    10,
      11,    12,     4,    14,    15,    16,    17,    56,     3,     3,
      21,    53,    54,    28,    37,    38,     3,    23,    59,    59,
      26,    44,    23,    32,    33,    26,    56,    57,    59,    22,
      22,    54,    60,     3,    59,     4,     3,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    77,    58,    58,    30,    55,     3,     4,    59,
       6,     7,     8,    84,    85,    59,    87,    59,    59,    59,
      91,    92,    18,    59,    55,   128,    97,    98,   178,    25,
     168,    17,    -1,    -1,     3,     4,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    25,    53,    54,    -1,
      -1,    -1,   133,    -1,   135,   136,   137,    -1,    -1,   140,
     141,   142,    -1,    -1,    -1,    -1,   147,    -1,    -1,   150,
      49,    50,    51,    -1,    53,    54,    -1,    -1,   159,   160,
      -1,    -1,     3,     4,    -1,     6,     7,    -1,   169,   174,
      -1,    -1,   173,    -1,   179,    -1,    -1,    -1,    19,    -1,
     185,   182,     3,     4,    25,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    47,    48,    -1,    50,
      51,    -1,    -1,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    -1,    -1,     3,     4,    59,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    -1,    -1,
       3,     4,    59,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    -1,    56,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,     3,     4,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
       3,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    -1,    21,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,     3,     4,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,     3,     4,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,     3,     4,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,     3,     4,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
       3,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    16,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,     3,     4,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    -1,    16,    17,    18,    -1,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    35,    -1,    -1,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,     3,     4,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    16,    -1,    18,
      -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,     3,     4,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    -1,    16,
      -1,    18,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
      -1,    -1,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,     3,     4,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
       3,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,     3,     4,    -1,     6,     7,     8,     9,    10,
      11,    12,    -1,    -1,    -1,     3,     4,    18,     6,     7,
       8,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      18,    -1,    -1,    34,    35,    -1,    -1,    25,    -1,    -1,
      -1,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    -1,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,     3,     4,    -1,
       6,     7,     8,    -1,    -1,     3,     4,    -1,     6,     7,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    19,    -1,    -1,    22,    -1,    -1,    25,    -1,    27,
      28,    29,    30,    31,    -1,     3,     4,    -1,     6,     7,
      -1,    47,    48,    49,    50,    51,    -1,    53,    54,    47,
      48,    19,    50,    51,    -1,    -1,    24,    25,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      48,    -1,    50,    51,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    -1,    49,
      -1,    -1,    -1,    53,    54
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    16,    37,    38,    44,    54,    62,    63,     3,     4,
       6,     7,    19,    25,    47,    48,    50,    51,    86,    89,
      92,    85,    32,    33,    65,    66,    67,    68,    71,    72,
      64,     0,    86,    86,    86,    86,    86,    27,    28,    29,
      30,    31,    86,    90,    91,    86,    87,    88,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    34,
      35,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    49,    53,    54,    86,    86,     4,    56,    81,     3,
      69,    81,    75,    65,    20,    59,    31,    59,    22,    23,
      26,    59,    36,    59,    23,    26,    22,     5,    36,    60,
      86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
      86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
      86,    86,    86,    86,    86,     3,     4,    81,    70,     3,
      73,    86,    86,    59,    86,    59,    59,    59,    86,    86,
      59,    59,    59,    86,    86,    88,    71,    55,    76,    79,
      21,    86,    86,    86,    86,    59,    86,    86,    86,     5,
      36,    24,    86,    74,    86,    86,    86,    77,    78,    36,
      56,    57,    80,    85,    86,    58,    69,    82,    81,    83,
      58,    69,    55,    79,    81,    84,    81
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 522 "parse.y"
    {
				compile_check( current_compile );
			}
    break;

  case 5:
#line 527 "parse.y"
    {
				char buf[MAX_STRSIZE];

				current_compile->tree = (yyvsp[(1) - (1)].yy_node);

				/* Junk any old text.
				 */
				IM_FREE( current_compile->text );
				IM_FREE( current_compile->prhstext );
				IM_FREE( current_compile->rhstext );

				/* Set new text.
				 */
				SETSTR( current_compile->rhstext,
					input_text( buf ) );

				compile_check( current_compile );
			}
    break;

  case 6:
#line 549 "parse.y"
    {
				(yyval.yy_node) = (yyvsp[(2) - (2)].yy_node);
			}
    break;

  case 7:
#line 554 "parse.y"
    {
				(yyval.yy_node) = (yyvsp[(2) - (2)].yy_node);
			}
    break;

  case 10:
#line 567 "parse.y"
    {
				tool_position += 1;
			}
    break;

  case 11:
#line 572 "parse.y"
    {
				tool_position += 1;
			}
    break;

  case 12:
#line 579 "parse.y"
    {
				Tool *tool;

				if( !is_top( current_symbol ) )
					yyerror( _( "not top level" ) );

				tool = tool_new_sep( current_kit, 
					tool_position );
				tool->lineno = input_state.lineno;

				input_reset();
			}
    break;

  case 13:
#line 593 "parse.y"
    {
				Tool *tool;

				if( !is_top( current_symbol ) )
					yyerror( _( "not top level" ) );

				/* Should have two strings.
				 */
				if( (yyvsp[(2) - (3)].yy_const).type != PARSE_CONST_STR || 
					(yyvsp[(3) - (3)].yy_const).type != PARSE_CONST_STR )
					yyerror( _( "not strings" ) );

				/* Add tool.
				 */
				tool = tool_new_dia( current_kit, 
					tool_position, 
					(yyvsp[(2) - (3)].yy_const).val.str, (yyvsp[(3) - (3)].yy_const).val.str );
				if( !tool )
					yyerror( error_get_sub() );
				tool->lineno = input_state.lineno;

				tree_const_destroy( &(yyvsp[(2) - (3)].yy_const) );
				tree_const_destroy( &(yyvsp[(3) - (3)].yy_const) );

				input_reset();
			}
    break;

  case 14:
#line 622 "parse.y"
    {
				last_top_sym = NULL;
				last_top_lineno = input_state.lineno;
				scope_reset();
				current_compile = root_symbol->expr->compile;
			}
    break;

  case 15:
#line 629 "parse.y"
    {
				Symbol *sym = last_top_sym;
				Tool *tool;

				assert( sym );

				/* Work out extra secret parameters for
				 * locals.
				 */
				secret_build( sym->expr->compile );

				/* Add to the current kit.
				 */
				tool = tool_new_sym( current_kit, 
					tool_position, sym );
				tool->lineno = last_top_lineno;

				/* Finished with this symbol.
				 */
				symbol_made( sym );

                                /* Compile.
                                 */
                                if( compile_heap( sym->expr->compile ) )
                                        yyerror( _( "unable to compile "
                                                "\"%s\"\n%s" ),
                                                IOBJECT( sym )->name,
                                                error_get_sub() );

				input_reset();
			}
    break;

  case 16:
#line 666 "parse.y"
    {	
				Symbol *sym;

				/* Is this a top-level definition? Check we've
				 * not defined any other top-level syms with
				 * this name in this parse action.
				 */
				if( current_symbol == root_symbol ) 
					if( (sym = slist_map( parse_sofar,
						(SListMapFn) iobject_test_name,
						(yyvsp[(1) - (1)].yy_name) )) )
							symbol_error_redefine( 
								sym );

				/* Make defining occurence.
				 */
				sym = symbol_new_defining( 	
					current_compile, (yyvsp[(1) - (1)].yy_name) );
				(void) symbol_user_init( sym );
				(void) compile_new_local( sym->expr );
				IM_FREE( (yyvsp[(1) - (1)].yy_name) );

				/* If this is to be a top-level-definition,
                                 * make a note of it.
                                 */
				if( current_symbol == root_symbol ) {
                                        last_top_sym = sym;

					/* Also note on list of syms for this
					 * action.
					 */
					parse_sofar = g_slist_prepend(
						parse_sofar, sym );
				}

				/* Initialise symbol parsing variables. Save
				 * old current symbol, add new one.
				 */
				scope_push();
				current_symbol = sym;
				current_compile = sym->expr->compile;

				assert( !current_compile->param );
				assert( current_compile->nparam == 0 );

				/* Junk any old def text.
				 */
				IM_FREE( current_compile->text );
				IM_FREE( current_compile->prhstext );
				IM_FREE( current_compile->rhstext );
			}
    break;

  case 17:
#line 718 "parse.y"
    {
				Compile *parent = compile_get_parent( 
					current_compile );
				/* Link unresolved names.
				 */
				compile_resolve_names( current_compile,
				    parent );

				/* Do some checking.
				 */
				compile_check( current_compile );

				scope_pop();
			}
    break;

  case 18:
#line 737 "parse.y"
    {	
				input_push( 1 );

				/* We've already read the character past the
				 * end of the identifier (that's why we know
				 * the identifier is over).
				 */
				input_back1();
			}
    break;

  case 19:
#line 747 "parse.y"
    {	
				input_push( 2 );
				input_backtoch( '=' );
			}
    break;

  case 20:
#line 752 "parse.y"
    {	
				current_compile->tree = (yyvsp[(4) - (4)].yy_node);
				assert( current_compile->tree );
				input_push( 4 );
			}
    break;

  case 21:
#line 758 "parse.y"
    {
				char buf[MAX_STRSIZE];

				input_pop();

				/* Save body text as rhstext.
				 */
				SETSTR( current_compile->rhstext,
					input_text( buf ) );
				input_pop();

				/* Save params '=' body as prhstext.
				 */
				SETSTR( current_compile->prhstext,
					input_text( buf ) );
				input_pop();

				/* Save full text of definition.
				 */
				SETSTR( current_compile->text,
					input_text( buf ) );

#ifdef DEBUG
				printf( "%s->compile->text = \"%s\"\n",
					IOBJECT( current_compile->sym )->name, 
					current_compile->text );
				printf( "%s->compile->prhstext = \"%s\"\n",
					IOBJECT( current_compile->sym )->name, 
					current_compile->prhstext );
				printf( "%s->compile->rhstext = \"%s\"\n",
					IOBJECT( current_compile->sym )->name, 
					current_compile->rhstext );
#endif /*DEBUG*/
			}
    break;

  case 23:
#line 798 "parse.y"
    {
				Symbol *sym = symbol_new_defining( 
					current_compile, (yyvsp[(2) - (2)].yy_name) );

				symbol_parameter_init( sym, current_compile );

				IM_FREE( (yyvsp[(2) - (2)].yy_name) );
			}
    break;

  case 24:
#line 810 "parse.y"
    {
				(yyval.yy_node) = (yyvsp[(3) - (3)].yy_node);
			}
    break;

  case 25:
#line 815 "parse.y"
    {
				(yyval.yy_node) = (yyvsp[(1) - (1)].yy_node);
			}
    break;

  case 26:
#line 821 "parse.y"
    {
				ParseNode *pn = tree_class_new(
					current_compile );

				input_push( 3 );
				scope_push();
				current_symbol = current_compile->super;
				current_compile =
					current_symbol->expr->compile;

				current_parsenode = pn;
			}
    break;

  case 27:
#line 834 "parse.y"
    {
				Compile *parent = compile_get_parent( 
					current_compile );
				char buf[MAX_STRSIZE];
				int len;

				(void) input_text( buf );

				/* Always read 1 char too many.
				 */
				if( (len = strlen( buf )) > 0 )
					buf[len - 1] = '\0';

				SETSTR( current_compile->rhstext, buf );
				input_pop();
				current_compile->tree = (yyvsp[(2) - (2)].yy_node);

				if( current_compile->tree->elist )
					parent->has_super = TRUE;

				/* Link unresolved names.
				 */
				compile_resolve_names( current_compile,
					parent );

				/* Do some checking.
				 */
				compile_check( current_compile );

				scope_pop();

				(yyval.yy_node) = current_parsenode;
				current_parsenode = NULL;
			}
    break;

  case 28:
#line 872 "parse.y"
    { 	
				(yyval.yy_node) = (yyvsp[(2) - (2)].yy_node);
			}
    break;

  case 29:
#line 877 "parse.y"
    { 	
				(yyval.yy_node) = tree_ifelse_new( current_compile,
					(yyvsp[(4) - (6)].yy_node), (yyvsp[(2) - (6)].yy_node), (yyvsp[(6) - (6)].yy_node) );
			}
    break;

  case 35:
#line 899 "parse.y"
    {
				input_pop();
				input_push( 5 );
			}
    break;

  case 37:
#line 907 "parse.y"
    {
				input_pop();
				input_push( 6 );
			}
    break;

  case 39:
#line 916 "parse.y"
    {
				(yyval.yy_node) = tree_super_new( current_compile );
			}
    break;

  case 40:
#line 923 "parse.y"
    {
				(yyval.yy_node) = tree_super_extend( current_compile, 
					(yyvsp[(1) - (2)].yy_node), (yyvsp[(2) - (2)].yy_node) );
			}
    break;

  case 41:
#line 931 "parse.y"
    { 
				(yyval.yy_node) = (yyvsp[(2) - (3)].yy_node);
			}
    break;

  case 42:
#line 936 "parse.y"
    {
				(yyval.yy_node) = tree_const_new( current_compile, (yyvsp[(1) - (1)].yy_const) );
			}
    break;

  case 43:
#line 941 "parse.y"
    {
				(yyval.yy_node) = tree_leaf_new( current_compile, (yyvsp[(1) - (1)].yy_name) );
				IM_FREE( (yyvsp[(1) - (1)].yy_name) );
			}
    break;

  case 44:
#line 947 "parse.y"
    {
				(yyval.yy_node) = tree_leaf_new( current_compile, 
					IOBJECT( symbol_get_scope( 
						current_symbol ) )->name );
			}
    break;

  case 45:
#line 955 "parse.y"
    {
				(yyval.yy_node) = tree_ifelse_new( current_compile,
					(yyvsp[(2) - (6)].yy_node), (yyvsp[(4) - (6)].yy_node), (yyvsp[(6) - (6)].yy_node) );
			}
    break;

  case 46:
#line 962 "parse.y"
    {
				(yyval.yy_node) = tree_appl_new( current_compile,
					(yyvsp[(1) - (2)].yy_node), (yyvsp[(2) - (2)].yy_node) );
			}
    break;

  case 47:
#line 968 "parse.y"
    {
				(yyval.yy_node) = (yyvsp[(2) - (3)].yy_node);
#ifdef DEBUG
				printf( "parsed list constant:\n" );
				dump_tree( (yyval.yy_node) );
#endif /*DEBUG*/
			}
    break;

  case 50:
#line 983 "parse.y"
    {
				(yyval.yy_node) = tree_generator_new( current_compile,
					(yyvsp[(1) - (2)].yy_node), NULL, NULL );
			}
    break;

  case 51:
#line 989 "parse.y"
    {
				(yyval.yy_node) = tree_generator_new( current_compile,
					(yyvsp[(1) - (3)].yy_node), NULL, (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 52:
#line 995 "parse.y"
    {
				(yyval.yy_node) = tree_generator_new( current_compile,
					(yyvsp[(1) - (4)].yy_node), (yyvsp[(3) - (4)].yy_node), NULL );
			}
    break;

  case 53:
#line 1001 "parse.y"
    {
				(yyval.yy_node) = tree_generator_new( current_compile,
					(yyvsp[(1) - (5)].yy_node), (yyvsp[(3) - (5)].yy_node), (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 55:
#line 1009 "parse.y"
    {
				ParseConst elist;

				elist.type = PARSE_CONST_ELIST;
				(yyval.yy_node) = tree_const_new( current_compile, elist );
			}
    break;

  case 56:
#line 1019 "parse.y"
    {
				(yyval.yy_node) = tree_lconst_extend( current_compile, 
					(yyvsp[(3) - (3)].yy_node), (yyvsp[(1) - (3)].yy_node) );
			}
    break;

  case 57:
#line 1025 "parse.y"
    {
				(yyval.yy_node) = tree_lconst_new( current_compile, (yyvsp[(1) - (1)].yy_node) );
			}
    break;

  case 58:
#line 1031 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_ADD, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 59:
#line 1036 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_CONS, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 60:
#line 1041 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_SUB, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 61:
#line 1046 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_SELECT, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 62:
#line 1051 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_DIV, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 63:
#line 1056 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_MUL, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 64:
#line 1061 "parse.y"
    {
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_REM, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 65:
#line 1066 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_JOIN, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 66:
#line 1071 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_POW, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 67:
#line 1076 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_LSHIFT, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 68:
#line 1081 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_RSHIFT, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 69:
#line 1086 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_EOR, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 70:
#line 1091 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_LAND, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 71:
#line 1096 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_BAND, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 72:
#line 1101 "parse.y"
    {	
				(yyval.yy_node) = tree_compose_new( current_compile, 
					(yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 73:
#line 1106 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_LOR, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 74:
#line 1111 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_BOR, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 75:
#line 1116 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_LESS, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 76:
#line 1121 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_LESSEQ, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 77:
#line 1126 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_LESS, (yyvsp[(3) - (3)].yy_node), (yyvsp[(1) - (3)].yy_node) );
			}
    break;

  case 78:
#line 1131 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_LESSEQ, (yyvsp[(3) - (3)].yy_node), (yyvsp[(1) - (3)].yy_node) );
			}
    break;

  case 79:
#line 1136 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_EQ, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 80:
#line 1141 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_NOTEQ, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 81:
#line 1146 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_PEQ, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 82:
#line 1151 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_PNOTEQ, (yyvsp[(1) - (3)].yy_node), (yyvsp[(3) - (3)].yy_node) );
			}
    break;

  case 83:
#line 1156 "parse.y"
    {
				ParseNode *tag = 
					tree_tag_new( current_compile, (yyvsp[(3) - (3)].yy_name) );

				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_DOT, (yyvsp[(1) - (3)].yy_node), tag );
				IM_FREE( (yyvsp[(3) - (3)].yy_name) );
			}
    break;

  case 84:
#line 1165 "parse.y"
    {	
				(yyval.yy_node) = tree_binop_new( current_compile,
					BI_COMMA, (yyvsp[(2) - (5)].yy_node), (yyvsp[(4) - (5)].yy_node) );
			}
    break;

  case 89:
#line 1181 "parse.y"
    {	
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CUCHAR, (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 90:
#line 1187 "parse.y"
    {	
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CSCHAR, (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 91:
#line 1194 "parse.y"
    {	
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CSSHORT, (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 92:
#line 1200 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CUSHORT, (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 93:
#line 1206 "parse.y"
    {	
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CSINT, (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 94:
#line 1212 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CUINT, (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 95:
#line 1218 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CFLOAT, (yyvsp[(4) - (4)].yy_node) );
			}
    break;

  case 96:
#line 1224 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CDOUBLE, (yyvsp[(4) - (4)].yy_node) );
			}
    break;

  case 97:
#line 1230 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CCOMPLEX, (yyvsp[(4) - (4)].yy_node) );
			}
    break;

  case 98:
#line 1236 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_CDCOMPLEX, (yyvsp[(5) - (5)].yy_node) );
			}
    break;

  case 99:
#line 1241 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_MINUS, (yyvsp[(2) - (2)].yy_node) );
			}
    break;

  case 100:
#line 1246 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_NEG, (yyvsp[(2) - (2)].yy_node) );
			}
    break;

  case 101:
#line 1251 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_COMPLEMENT, (yyvsp[(2) - (2)].yy_node) );
			}
    break;

  case 102:
#line 1256 "parse.y"
    {
				(yyval.yy_node) = tree_unop_new( current_compile,
					UN_PLUS, (yyvsp[(2) - (2)].yy_node) );
			}
    break;


/* Line 1267 of yacc.c.  */
#line 3110 "parse.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 1262 "parse.y"


/* Interface to parser. 
 */
static gboolean
parse_input( int ch, Symbol *sym, Toolkit *kit, int pos )
{
	current_kit = kit;
	current_symbol = sym;
	root_symbol = sym;
	tool_position = pos;
	last_top_sym = NULL;

	scope_reset();
	input_reset();

	/* Signal start nonterminal to parser.
	 */
	ip_unput( ch );

	if( setjmp( parse_error_point ) ) {
		if( current_compile ) 
			compile_error_set( current_compile );

		IM_FREEF( g_slist_free, parse_sofar );

		return( FALSE );
	}
	yyparse();
	IM_FREEF( g_slist_free, parse_sofar );

	/* All ok.
	 */
	return( TRUE );
}

/* Parse the input into a set of symbols into a position in a kit. 
 * kit may be NULL for no kit. 
 */
gboolean
parse_toplevel( Toolkit *kit, int pos )
{
	gboolean result;

	current_compile = NULL;

	result = parse_input( '.', kit->kitg->root, kit, pos );

	if( kit )
		iobject_changed( IOBJECT( kit ) );

	return( result );
}

/* Parse a single top-level definition.
 */
gboolean
parse_onedef( Toolkit *kit, int pos )
{
	gboolean result;

	current_compile = NULL;

	result = parse_input( '^', kit->kitg->root, kit, pos );

	if( kit )
		iobject_changed( IOBJECT( kit ) );

	return( result );
}

/* Parse new text into "expr". If params is set, str should be "a b = a+b"
 * (ie. include params), if not, then just rhs (eg. "a+b").
 */
gboolean
parse_rhs( Expr *expr, ParseRhsSyntax syntax )
{
	static const char start_ch_table[] = {
		'&',		/* PARSE_RHS */
		'*',		/* PARSE_PARAMS */		
		'@'		/* PARSE_SUPER */
	};

	char start_ch = start_ch_table[(int) syntax];
	Compile *compile = compile_new_local( expr );

	current_compile = compile;
	if( !parse_input( start_ch, expr->sym, NULL, -1 ) ) {
		current_compile = NULL;
		return( FALSE );
	}
	current_compile = NULL;

	/* Resolve any dynamic refs.
	 */
	expr_resolve( expr );

	/* Work out extra secret parameters for locals.
	 */
	secret_build( compile );

	/* Compile.
	 */
	if( compile_heap( compile ) )
		return( FALSE );

	return( TRUE );
}

